using System;
using System.Configuration;
using System.Web;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;
using System.Collections.Specialized;
using System.Collections.Generic;

namespace Subgurim.Controles.SSM
{

    /// <summary>
    /// Summary description for Robot
    /// </summary>
    public class SubgurimRobot
    {
        public SubgurimRobot()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private static string spiderMe()
        {
            return spiderMe(HttpContext.Current.Request.Url);
        }

        private static string spiderMe(Uri url)
        {
            Uri baseUri;
            if (url.Authority.Contains("localhost:"))
            {
                string localExtra = url.LocalPath.Substring(0, url.LocalPath.IndexOf("/", 1));
                baseUri = new Uri(url.Scheme + Uri.SchemeDelimiter + url.Authority + localExtra + "/");
            }
            else
            {
                baseUri = new Uri(url.Scheme + Uri.SchemeDelimiter + url.Authority);
            }

            StringCollection urls = new StringCollection();
            urls.Add(preparaUrl(url.AbsoluteUri));
            urls.Add(preparaUrl(baseUri.AbsoluteUri));


            //cambios(getHTML(url), baseUri, ref urls, 0);
            cambios(getHTML(baseUri), baseUri, ref urls, 0);

            StringBuilder sb = new StringBuilder();
            foreach (string s in urls)
            {
                sb.Append(s);
                sb.Append("<br />");
            }

            return sb.ToString();
        }

        private static void cambios(string texto, Uri baseUri, ref StringCollection urls, int deepLevel)
        {
            string pattern_hRef = @"(?<=<a[^<>]+href=""?)[^""<>]+(?=""?[^<>]*>)";

            MatchCollection col = Regex.Matches(texto, pattern_hRef, RegexOptions.IgnoreCase);

            Uri href;
            string _aux;
            bool X = true;
            foreach (Match match in col)
            {
                if (Uri.IsWellFormedUriString(match.Value, UriKind.Absolute))
                    href = new Uri(match.Value);
                else if (Uri.IsWellFormedUriString(match.Value, UriKind.Relative))
                {
                    href = new Uri(SubgurimSiteMapUtilities.makeRelative(baseUri.AbsoluteUri, match.Value));
                    
                }
                else continue;


                if (baseUri.DnsSafeHost.Replace("www.", string.Empty)
                    == href.DnsSafeHost.Replace("www.", string.Empty))
                {
                    _aux = preparaUrl(href.AbsoluteUri);

                    if (!urls.Contains(_aux))
                    {
                        urls.Add(_aux);

                        if (X && (deepLevel < 1))
                        {
                            System.Threading.Thread.Sleep(1500);
                            X = false;
                            cambios(getHTML(new Uri(_aux)), baseUri, ref urls, ++deepLevel);
                        }
                    }
                }
            }
        }

        private static string preparaUrl(string url)
        {
            string _aux = url;
            _aux = _aux.EndsWith("/") ? _aux.Substring(0, _aux.Length - 1) : _aux;
            _aux = _aux.EndsWith("#") ? _aux.Substring(0, _aux.Length - 1) : _aux;
            _aux = _aux.Trim();

            return _aux;
        }

        private static string getHTML(Uri url)
        {
            string retorno = string.Empty;

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            try
            {
                using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())
                {
                    if (response.StatusCode == HttpStatusCode.OK)
                    {
                        StreamReader sr = new StreamReader(response.GetResponseStream());
                        retorno = sr.ReadToEnd();
                    }
                }
            }
            catch
            { retorno = string.Empty; }

            return retorno;
        }

    }
}